LeetCode 300. Longest Increasing Subsequence

来源:互联网 发布:java泛型方法 编辑:程序博客网 时间:2024/05/18 01:49

题目:
Given an unsorted array of integers, find the length of longest increasing subsequence.

For example,
Given [10, 9, 2, 5, 3, 7, 101, 18],
The longest increasing subsequence is [2, 3, 7, 101], therefore the length is 4. Note that there may be more than one LIS combination, it is only necessary for you to return the length.

Your algorithm should run in O(n2) complexity.

Follow up: Could you improve it to O(n log n) time complexity?

思路: 就是简单的动态规划问题 ,因为没有最长子串是,长度也为1,而且nums[j]<nums[i]时,那么dp[i]就为dp[i]和dp[j]+1的大的那个值 。

代码:

class Solution {public:    int lengthOfLIS(vector<int>& nums) {        int size = nums.size();        if (size == 0) { //如果nums为空,直接返回0            return 0;         }        vector<int> dp(size, 1);//dp初始化为1,因为当没有连续时,长度为1        int res = 1;        for (int i = 1; i < size; ++i) {            for (int j = 0; j < i; ++j) {                if (nums[j] < nums[i]) {//动态规划,如果nums[j]<nums[i],那么dp[i]就为dp[i]和dp[j]+1的大的那个值                     dp[i] = max(dp[i], dp[j] + 1);                }            }            res = max(res, dp[i]);//每次处循环结束,更新res的值        }        return res;    }};

结果: 33ms

原创粉丝点击